import { ModuleWithProviders } from '@angular/core';
import { AuthenticationServiceConfig } from './authentication/model/authentication.service.config';
import { EmailServiceConfig } from './email/model/email.service.config';
import { EmployeeServiceConfig } from './employee/model/employee.service.config';
import { SharePointServiceConfig } from './sharepoint/model/sharepoint.service.config';
export * from './authentication/model/authentication.service.config';
export * from './email/model/email.service.config';
export * from './employee/model/employee.service.config';
export * from './sharepoint/model/sharepoint.service.config';
export * from './authentication/model/authentication-token';
export * from './email/model/email';
export * from './employee/model/employee';
export * from './sharepoint/model/sharepoint-calendar-event';
export * from './sharepoint/model/sharepoint-customer-visit';
export * from './sharepoint/model/sharepoint-employee-picture';
export * from './sharepoint/model/sharepoint-list-item';
export * from './sharepoint/model/sharepoint-list';
export * from './sharepoint/model/sharepoint-person';
export * from './sharepoint/model/sharepoint-picture';
export * from './authentication/service/authentication.service';
export * from './email/service/email.service';
export * from './employee/service/employee.service';
export * from './sharepoint/service/sharepoint.service';
export * from './employee/pipe/departments.pipe';
export * from './employee/pipe/employee-by-dn.pipe';
export * from './employee/pipe/employee-photo-url.pipe';
export * from './employee/pipe/employees-with-property-value.pipe';
export * from './employee/pipe/is-member-of.pipe';
export * from './sharepoint/pipe/sharepoint-photo-url.pipe';
export * from './sharepoint/pipe/sharepoint-url.pipe';
export * from './employee/pipe/sort-employees.pipe';
export * from './misc/components/confirmation-dialog/confirmation-dialog.component';
export * from './authentication/components/login/login.component';
export * from './authentication/components/login-form/login-form.component';
export * from './misc/miscellaneous.module';
export declare class EmailModule {
    static forRoot(emailConfig: EmailServiceConfig): ModuleWithProviders;
    constructor(parentModule: EmailModule);
}
export declare class SharePointModule {
    static forRoot(sharePointConfig: SharePointServiceConfig): ModuleWithProviders;
    constructor(parentModule: SharePointModule);
}
export declare class EmployeeModule {
    static forRoot(employeeConfig: EmployeeServiceConfig): ModuleWithProviders;
    constructor(parentModule: EmployeeModule);
}
export declare class AuthenticationModule {
    static forRoot(authenticationConfig: AuthenticationServiceConfig): ModuleWithProviders;
    constructor(parentModule: AuthenticationModule);
}
